library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

--  Uncomment the following lines to use the declarations that are
--  provided for instantiating Xilinx primitive components.
--library UNISIM;
--use UNISIM.VComponents.all;

-- Bis 240 000 Zaehle bei 48 Mhz Takt

entity Clock_Generator is

port ( Reset, CLK 			: in std_logic;
	  CLK_100Hz, CLK_1kHz	: out std_logic	);

end Clock_Generator;

architecture Takteiler of Clock_Generator is

  signal Q : std_logic_vector (12 downto 0);
  signal QK: std_logic_vector (8 downto 0);
  signal CLK_100Hz_Temp : std_logic;
  signal CLK_1kHz_Temp  : std_logic;

begin

  process(CLK, Reset)
  begin
    
    if Reset = '1' then
      
	 Q <= (others => '0');
      QK <= (others => '0');
      
	 CLK_100Hz_Temp <= '0';
    	 CLK_1kHz_Temp  <= '0';
    
    elsif CLK'Event and CLK = '1' then
    
      if Q < x"1387" then	-- Counter fuer 100Hz, 3A97F , 48MHZ
        Q <= Q + 1;
      else
        Q <= (others => '0');
        CLK_100Hz_Temp <= not CLK_100Hz_Temp;
      end if;

      if QK < x"1F3" then	-- Counter fuer 1000Hz, 5DBF , 48Mhz
        QK <= QK + 1;
      else
        QK <= (others => '0');
        CLK_1kHz_Temp <= not CLK_1Khz_Temp;
      end if;
    
    end if;
  
  end process;

  CLK_100Hz <= CLK_100Hz_Temp;
  CLK_1kHz <= CLK_1kHz_Temp;

end Takteiler;

