library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

-- PWM Dekodierung PWM Signal

entity PWM_Decoder is

port ( sig,msClk,rst	: in std_logic;
	  bitVal,bitClkOut,
	  minClkOut, error 	: out std_logic );	
	  --CNT 			: out std_logic_vector ( 7 downto 0));
end PWM_Decoder;

architecture Decoder of PWM_Decoder is

-- Signale und Deklaratioenen
signal timCnt: std_logic_vector ( 7 downto 0);
signal delSig: std_logic;
signal temp  : std_logic;
signal mintemp : std_logic;
begin
  
  Check_DCF_Signal: process ( rst, msClk )
  
  begin
    
    if rst = '1' then
    		timCnt <= (others => '0');
    		bitVal <= '0';
		bitClkOut <= '0';
		minClkOut <= '0';
    		delSig 	<= '0';
		error     <= '0';

    elsif msClk = '1' and msClk'event then
		
		delSig <= sig;	 
		temp <= sig and (not delSig);
		--bitVal <= sig and (not delSig);
		
			 
	 	if timCnt >= x"82" or temp = '1' then

			--bitClkOut <= '1';
			if timCnt >= x"82" then
				
				mintemp   <= '1';
				
				bitClkOut <= '0';
				
				timCnt <= timCnt - x"64";
				
			else
				bitClkOut <= '1';
				
				if mintemp = '1' then
					minClkOut <= '1';
					error     <= '0';
					mintemp   <= '0';
				end if;
				
				if  timCnt >= x"55" and timCnt <= x"5F" then
					bitVal <= '0';
					timCnt <= (others => '0');
				
				elsif timCnt >= x"4B" and timCnt <= x"54" then
					bitVal <= '1';
					timCnt <= (others => '0');
				
				else
					bitVal <= '0';
					bitClkOut <= '0';
					minClkOut <= '0';
					error     <= '1';
					timCnt <= (others => '0');
				end if;
			end if;

		 else

		 	if timCnt = x"05" then 
	 			bitClkOut <= '0';
				minClkOut <= '0';
			end if;

			if sig = '0' then
				timCnt <= timCnt +1;
			end if;
		
		end if;
	end if;
	 
  end process Check_DCF_Signal;

	
     --CNT <= timCnt;
end Decoder;