library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

--  Uncomment the following lines to use the declarations that are
--  provided for instantiating Xilinx primitive components.
--library UNISIM;
--use UNISIM.VComponents.all;

entity shift is  
	port(Unload, Reset, C, SI : in  std_logic;        
		Stunden_10er : out std_logic_vector (3 downto 0);
		Stunden_1er  : out std_logic_vector (3 downto 0);
		Minuten_10er : out std_logic_vector (3 downto 0);
		Minuten_1er  : out std_logic_vector (3 downto 0));
		--Registerle   : out std_logic_vector (58 downto 0));
		--DCF_Word	   : out std_logic_vector (58 downto 0));

end shift;

architecture archi of shift is

signal tmp: std_logic_vector(58 downto 0);  
signal Zehner_Minuten : std_logic_vector(3 downto 0);
signal Einer_Minuten  : std_logic_vector(3 downto 0);
signal Zehner_Stunden : std_logic_vector(3 downto 0);
signal Einer_Stunden  : std_logic_vector(3 downto 0);

begin    
	process (C, Reset, Unload, tmp)      
		begin        
		
		if Reset = '1' then
			tmp <= ( others => '0' );
			Zehner_Minuten <= "1011";
			Einer_Minuten  <= "1011";
			Zehner_Stunden <= "1011";
			Einer_Stunden  <= "1011";

		elsif (C'event and C='1') then  
			for i in 0 to 57 loop
				tmp(i+1) <= tmp(i);
	          end loop;
			 tmp(0) <= SI;
	     
			if Unload = '1' then
			
			Einer_Minuten(0) <= tmp(36); -- 37
			Einer_Minuten(1) <= tmp(35); -- 36
			Einer_Minuten(2) <= tmp(34); -- 35
			Einer_Minuten(3) <= tmp(33); -- 34

			Zehner_Minuten(0) <= tmp(32);
			Zehner_Minuten(1) <= tmp(31);
			Zehner_Minuten(2) <= tmp(30);
			Zehner_Minuten(3) <= '0';

			Einer_Stunden(0) <= tmp(28);
			Einer_Stunden(1) <= tmp(27);
			Einer_Stunden(2) <= tmp(26);
			Einer_Stunden(3) <= tmp(25);

			Zehner_Stunden(0) <= tmp(24);
			Zehner_Stunden(1) <= tmp(23); 
			Zehner_Stunden(2) <= '0';
			Zehner_Stunden(3) <= '0';
			--DCF_Word <= tmp;
			end if;
		 end if;
		--Registerle <= tmp;
end process;    

 	

Stunden_10er <= Zehner_Stunden;
Stunden_1er  <= Einer_Stunden;
Minuten_10er <= Zehner_Minuten;
Minuten_1er  <= Einer_Minuten;

end archi;