-- Vhdl test bench created from schematic dcf_uhr.sch - Wed May 18 19:30:56 2005
--
-- Notes: 
-- 1) This testbench template has been automatically generated using types
-- std_logic and std_logic_vector for the ports of the unit under test.
-- Xilinx recommends that these types always be used for the top-level
-- I/O of a design in order to guarantee that the testbench will bind
-- correctly to the timing (post-route) simulation model.
-- 2) To use this template as your testbench, change the filename to any
-- name of your choice with the extension .vhd, and use the "Source->Add"
-- menu in Project Navigator to import the testbench. Then
-- edit the user defined section below, adding code to generate the 
-- stimulus for your design.
--
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;
LIBRARY UNISIM;
USE UNISIM.Vcomponents.ALL;
ENTITY testbench4 IS
END testbench4;
ARCHITECTURE behavioral OF testbench4 IS 

   COMPONENT dcf_uhr
   PORT( synced	:	OUT	STD_LOGIC; 
          DCF_Sig	:	IN	STD_LOGIC; 
          BitClk	:	OUT	STD_LOGIC; 
          Errr	:	OUT	STD_LOGIC; 
          MinClk	:	OUT	STD_LOGIC; 
          BitV	:	OUT	STD_LOGIC; 
          Std10	:	OUT	STD_LOGIC_VECTOR (3 DOWNTO 0); 
          Std1	:	OUT	STD_LOGIC_VECTOR (3 DOWNTO 0); 
          Min10	:	OUT	STD_LOGIC_VECTOR (3 DOWNTO 0); 
          Min1	:	OUT	STD_LOGIC_VECTOR (3 DOWNTO 0); 
          Regist	:	OUT	STD_LOGIC_VECTOR (58 DOWNTO 0); 
          Reset	:	IN	STD_LOGIC; 
          MUX	:	OUT	STD_LOGIC_VECTOR (2 DOWNTO 0); 
          Segmente	:	OUT	STD_LOGIC_VECTOR (6 DOWNTO 0); 
          CLK	:	IN	STD_LOGIC);
   END COMPONENT;

   SIGNAL synced	:	STD_LOGIC;
   SIGNAL DCF_Sig	:	STD_LOGIC;
   SIGNAL BitClk	:	STD_LOGIC;
   SIGNAL Errr	:	STD_LOGIC;
   SIGNAL MinClk	:	STD_LOGIC;
   SIGNAL BitV	:	STD_LOGIC;
   SIGNAL Std10	:	STD_LOGIC_VECTOR (3 DOWNTO 0);
   SIGNAL Std1	:	STD_LOGIC_VECTOR (3 DOWNTO 0);
   SIGNAL Min10	:	STD_LOGIC_VECTOR (3 DOWNTO 0);
   SIGNAL Min1	:	STD_LOGIC_VECTOR (3 DOWNTO 0);
   SIGNAL Regist	:	STD_LOGIC_VECTOR (58 DOWNTO 0);
   SIGNAL Reset	:	STD_LOGIC;
   SIGNAL MUX	:	STD_LOGIC_VECTOR (2 DOWNTO 0);
   SIGNAL Segmente	:	STD_LOGIC_VECTOR (6 DOWNTO 0);
   SIGNAL CLK	:	STD_LOGIC;

BEGIN

   UUT: dcf_uhr PORT MAP(
		synced => synced, 
		DCF_Sig => DCF_Sig, 
		BitClk => BitClk, 
		Errr => Errr, 
		MinClk => MinClk, 
		BitV => BitV, 
		Std10 => Std10, 
		Std1 => Std1, 
		Min10 => Min10, 
		Min1 => Min1, 
		Regist => Regist, 
		Reset => Reset, 
		MUX => MUX, 
		Segmente => Segmente, 
		CLK => CLK
   );

-- *** Test Bench - User Defined Section ***
  tbDCF_Sync_Sig : PROCESS		-- Reset
BEGIN
  Reset <= '1';
  wait for 100 us;	 
  Reset <= '0';
  wait;
END PROCESS;

PROCESS 					-- Clock 1Mhz
BEGIN
  CLK <= '0';
  wait for 5 us;
  for i in 1 to 90000000 loop  
    CLK <= '1';
    wait for 500 ns; --
    CLK <= '0';
    wait for 500 ns;
  end loop;
  wait;
END PROCESS;


PROCESS					-- DCF Signal Test einer Uhrzeit
BEGIN
  DCF_Sig <= '0';
  wait for 100ms;

  DCF_Sig <= '1';			-- Logische 1	
  wait for 2ms;	 
  DCF_Sig <= '0';
  wait for 2800ms;	 

  DCF_Sig <= '1';			-- Logische 0	+ MIN Sprung
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 1900ms;	 
  
  DCF_Sig <= '1';			-- Logische 0   1
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 
  
  DCF_Sig <= '1';			-- Logische 0	 2
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 3
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 4
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 5
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 6
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 7
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 8
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 9
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 10
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 11
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 12
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 13
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 14
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 15
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 16
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 17
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 18
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 
  
  DCF_Sig <= '1';			-- Logische 0	 19
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1   20
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 21
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 22
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 1	 23
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 24
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 25
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 26
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 27
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 28
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 1	 29
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 30
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 31
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 32
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 33
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 34
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 1	 35
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 36
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 37
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 1	 38
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 39
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 40
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 41
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 42
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 43
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 44
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 45
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 46
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 1	 47
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 48
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 49
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 50
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 51
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 52
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 53
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 
 
  DCF_Sig <= '1';			-- Logische 0	 54
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 55
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 56
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 57
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 	     -- Jetzt sind 57 Sekunden vorbei

  DCF_Sig <= '1';			-- Logische 0	 58
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 	     -- Jetzt sind 58 Sekunden vorbei

  
  DCF_Sig <= '1';			-- Logische 0	 59. + Min Sprung
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 1900ms;	 	    -- Jetzt sind 60 Sekunden vorbei

----
  
  DCF_Sig <= '1';			-- Logische 0   1
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 
  
  DCF_Sig <= '1';			-- Logische 0	 2
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 3
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 4
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 5
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 6
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 7
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 8
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 9
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 10
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 11
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 12
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 13
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 14
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 15
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 16
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 17
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 18
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 
  
  DCF_Sig <= '1';			-- Logische 0	 19
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1   20
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 21
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 22
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 1	 23
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 24
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 25
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 26
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 27
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 28
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 1	 29
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 30
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 31
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 32
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 33
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 34
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 1	 35
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 36
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 37
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 1	 38
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 39
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 40
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 41
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 42
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 43
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 44
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 45
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 46
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 1	 47
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 48
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 49
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 50
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 51
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 52
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 53
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 
 
  DCF_Sig <= '1';			-- Logische 0	 54
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 55
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 56
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 57
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 	     -- Jetzt sind 57 Sekunden vorbei

  DCF_Sig <= '1';			-- Logische 0	 58
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 	     -- Jetzt sind 58 Sekunden vorbei

  
  DCF_Sig <= '1';			-- Logische 0	 59. + Min Sprung
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 1900ms;	 	    -- Jetzt sind 60 Sekunden vorbei


---
  DCF_Sig <= '1';			-- Logische 1	 1
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 2
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait;

END PROCESS;

-- *** End Test Bench - User Defined Section ***

END;
