-- Vhdl test bench created from schematic dcf_uhr.sch - Wed May 18 13:00:11 2005
--
-- Notes: 
-- 1) This testbench template has been automatically generated using types
-- std_logic and std_logic_vector for the ports of the unit under test.
-- Xilinx recommends that these types always be used for the top-level
-- I/O of a design in order to guarantee that the testbench will bind
-- correctly to the timing (post-route) simulation model.
-- 2) To use this template as your testbench, change the filename to any
-- name of your choice with the extension .vhd, and use the "Source->Add"
-- menu in Project Navigator to import the testbench. Then
-- edit the user defined section below, adding code to generate the 
-- stimulus for your design.
--
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;
LIBRARY UNISIM;
USE UNISIM.Vcomponents.ALL;
ENTITY testbench IS
END testbench;
ARCHITECTURE behavioral OF testbench IS 

   COMPONENT dcf_uhr
   PORT(  CLK	:	IN	STD_LOGIC; 
          CLK1k:	IN	STD_LOGIC; 
		DCF_Sig	:	IN	STD_LOGIC; 
          Reset	:	IN	STD_LOGIC; 
         BitV		:	OUT	STD_LOGIC; 
	BitClk	:	OUT	STD_LOGIC; 
	BitMin	:	OUT	STD_LOGIC; 
	Error     :    OUT	STD_LOGIC; 
		MUX	:	OUT	STD_LOGIC_VECTOR (2 DOWNTO 0); 
          Display	:	OUT	STD_LOGIC_VECTOR (6 DOWNTO 0);
   	ShiftReg  :    OUT	STD_LOGIC_VECTOR (58 DOWNTO 0));
   
   END COMPONENT;

   SIGNAL CLK	:	STD_LOGIC;
   SIGNAL CLK1k:	STD_LOGIC;
   SIGNAL DCF_Sig	:	STD_LOGIC;
   SIGNAL Reset	:	STD_LOGIC;
  SIGNAL ShiftReg  :    STD_LOGIC_VECTOR (58 DOWNTO 0);
   SIGNAL MUX	:	STD_LOGIC_VECTOR (2 DOWNTO 0);
  SIGNAL BitV		:	STD_LOGIC; 
  SIGNAL	BitClk	:	STD_LOGIC; 
  SIGNAL	BitMin	:	STD_LOGIC; 
  SIGNAL	Error     :    STD_LOGIC; 
   SIGNAL Display	:	STD_LOGIC_VECTOR (6 DOWNTO 0);

BEGIN

   UUT: dcf_uhr PORT MAP(
		CLK => CLK, 
		CLK1k => CLK1k,
		DCF_Sig => DCF_Sig, 
		Reset => Reset, 
		MUX => MUX, 
		ShiftReg => ShiftReg,
	BitV	  => BitV,
	BitClk =>	BitClk,
	BitMin =>	BitMin,
	Error  =>	Error,
		Display => Display
   
   );

-- *** Test Bench - User Defined Section ***

tbDCF_Sync_Sig : PROCESS		-- Reset
BEGIN
  Reset <= '1';
  wait for 10000 ms;	 
  Reset <= '0';
  wait;
END PROCESS;

PROCESS 					-- Clock 100Hz
BEGIN
  CLK <= '0';
  wait for 5 us;
  for i in 1 to 10000 loop  
    CLK <= '1';
    wait for 5 ms; --
    CLK <= '0';
    wait for 5 ms;
  end loop;
  wait;
END PROCESS;


PROCESS 					-- Clock 1000Hz
BEGIN
  CLK1k <= '0';
  wait for 5 us;
  for l in 1 to 80000 loop  
    CLK1k <= '1';
    wait for 500 us; --
    CLK1k <= '0';
    wait for 500 us;
  end loop;
  wait;
END PROCESS;



PROCESS					-- DCF Signal Test einer Uhrzeit
BEGIN
  DCF_Sig <= '0';
  wait for 100ms;

  DCF_Sig <= '1';			-- Logische 1	
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	+ MIN Sprung
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 1900ms;	 
  
  DCF_Sig <= '1';			-- Logische 0   1
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 
  
  DCF_Sig <= '1';			-- Logische 0	 2
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 3
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 4
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 5
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 6
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 7
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 8
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 9
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 10
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 11
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 12
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 13
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 14
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 15
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 16
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 17
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 18
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 
  
  DCF_Sig <= '1';			-- Logische 0	 19
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1   20
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 21
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 22
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 1	 23
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 24
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 25
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 26
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 27
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 28
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 1	 29
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 30
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 31
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 32
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 33
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 34
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 1	 35
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 36
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 37
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 1	 38
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 39
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 40
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 41
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 42
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 43
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 44
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 45
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 46
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 1	 47
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 48
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 49
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 50
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 51
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 52
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 53
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 
 
  DCF_Sig <= '1';			-- Logische 0	 54
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 55
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 56
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 57
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 58 + 59.
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 1900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 1
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 2
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait;

END PROCESS;

-- *** End Test Bench - User Defined Section ***

END;
