-- Vhdl test bench created from schematic dcf_uhr.sch - Sun May 22 23:49:04 2005
--
-- Notes: 
-- 1) This testbench template has been automatically generated using types
-- std_logic and std_logic_vector for the ports of the unit under test.
-- Xilinx recommends that these types always be used for the top-level
-- I/O of a design in order to guarantee that the testbench will bind
-- correctly to the timing (post-route) simulation model.
-- 2) To use this template as your testbench, change the filename to any
-- name of your choice with the extension .vhd, and use the "Source->Add"
-- menu in Project Navigator to import the testbench. Then
-- edit the user defined section below, adding code to generate the 
-- stimulus for your design.
--
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;
LIBRARY UNISIM;
USE UNISIM.Vcomponents.ALL;
ENTITY testbench IS
END testbench;
ARCHITECTURE behavioral OF testbench IS 

   COMPONENT dcf_uhr
   PORT( DCF_Sig	:	IN	STD_LOGIC; 
          Reset	:	IN	STD_LOGIC; 
          MUX	:	OUT	STD_LOGIC_VECTOR (2 DOWNTO 0); 
          Segmente	:	OUT	STD_LOGIC_VECTOR (6 DOWNTO 0); 
          CLK	:	IN	STD_LOGIC);
   END COMPONENT;

   SIGNAL DCF_Sig	:	STD_LOGIC;
   SIGNAL Reset	:	STD_LOGIC;
   SIGNAL MUX	:	STD_LOGIC_VECTOR (2 DOWNTO 0);
   SIGNAL Segmente	:	STD_LOGIC_VECTOR (6 DOWNTO 0);
   SIGNAL CLK	:	STD_LOGIC;

BEGIN

   UUT: dcf_uhr PORT MAP(
		DCF_Sig => DCF_Sig, 
		Reset => Reset, 
		MUX => MUX, 
		Segmente => Segmente, 
		CLK => CLK
   );

-- *** Test Bench - User Defined Section ***

-- Hinweise: Die Testbench laeuft ohne Frequenzteiler
-- und wird direkt mit einem 100Hz Takt getaktet, den
-- normal der Frequenteiler (clock-generatot.vhd)
-- aus einer 1 Mhz Quelle erzeugt. Das fr den Multiplexer
-- vorgesehene Signal von 1khz wird hier in der Simulation
-- vereinfacht auch mit 100 Hz angenommen. Im Schematic 
-- DCF_UHR.sch sieht man die Zusammenhnge der Modelle.
 
-- Das DCF Signal (beide minuten gleich) das diese Testbench an den Eingang
-- DCF_SIG Taktet, soll folgende Uhrzeit darstellen:

-- 21:26	 ( Siehe auch Datei: tabelle.doc und
-- Impulsbild.jpg)

-- Das VHDL Modell shift in ShiftReg.vhd greift diese
-- werte parallel im Schieberegister ab und gibt sie
-- auf die Vektoren/Signale: Stunden10er , Stunden1er,
-- Minuten10er und Minuten 1er aus.

-- Der Abgriff der Werte (von signal tmp in ShiftReg.vhd),
---wie er jetzt gerade erfolgt,
-- liefert bei der Simulation andere Werte, als bei
-- der realen Hardware:

-- Werte Simulation/Hardware , binaer :
-- Stunden10er:  0011  [ Hardware : 0010 ] 
-- Stunden1er :  0000  [ Hardware : 0001 ] 
-- Minuten10er:  0101  [ Hardware : 0010 ] 
-- Stunden1er :  0011  [ Hardware : 0110 ] 

-- siehe auch tabelle.doc !

-- Irgendetwas muss nach meiner Meinung im Modell shift
-- schief laufen ? wird da was bloed systhetesiert ?
-- findest du den Fehler, so dass dann simulation und
-- realitaet zusammenpassen  ?


-- Hier noch zu den Funktionsbloecken:

-- Clock_Generator:
-- Teilt 1Mhz Signal in ein 1khz (fuer Multiplexer)
-- und 100Hz Signal (fuer Decoder etc..)

-- dcf_syncer:
-- Sinchronisiert DCF PWM Signal mit dem Clocksignal
-- der Schaltung

-- pwm decoder:
-- bitClkOut zeigt an das ein neues ausgewertetes
-- bit an bitvak zu verfuegung steht.
-- minClkOut zeigt an das eine neue Minute begonnen hat
-- error wenn das pwm verhaeltnis weder logisch 1 noch 0
-- ergibt.

-- Sift:
-- Speichert die Bits von BitVal Seriell mit bitCLK getaktet
-- und gibt sie mit bitClk paralell aus.
-- Hier muss der Fehler liegen, da die Daten in der
-- Simulation, anderst parallel ausgegeben werden, 
-- als es dann in der realen hardware der fall ist.
-- Vermutlich der Kern des Problems.

-- led_multiplexer:
-- gibt die Daten auf 7 Segmente usw aus... 
-- ist glaub fr die Fehlersuche nicht relevant... 




  tbDCF_Sync_Sig : PROCESS		-- Reset
BEGIN
  Reset <= '1';
  wait for 100 us;	 
  Reset <= '0';
  wait;
END PROCESS;

PROCESS 					-- Clock 100hz anstatt 1Mhz mit Frequenzteiler. 
BEGIN
  CLK <= '0';
  wait for 5 us;
  for i in 1 to 14000 loop  
    CLK <= '1';
    wait for 5 ms; --
    CLK <= '0';
    wait for 5 ms;
  end loop;
  wait;
END PROCESS;


PROCESS					-- DCF Signal Test einer Uhrzeit
BEGIN
  DCF_Sig <= '0';
  wait for 100ms;

  DCF_Sig <= '1';			-- Logische 1	
  wait for 2ms;	 
  DCF_Sig <= '0';
  wait for 2800ms;	 

  DCF_Sig <= '1';			-- Logische 0	+ MIN Sprung
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 1900ms;	 
  
  DCF_Sig <= '1';			-- Logische 0   1
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 
  
  DCF_Sig <= '1';			-- Logische 0	 2
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 3
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 4
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 5
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 6
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 7
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 8
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 9
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 10
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 11
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 12
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 13
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 14
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 15
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 16
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 17
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 18
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 
  
  DCF_Sig <= '1';			-- Logische 0	 19
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1   20
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 21
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 22
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 1	 23
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 24
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 25
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 26
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 27
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 28
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 1	 29
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 30
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 31
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 32
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 33
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 34
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 1	 35
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 36
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 37
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 1	 38
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 39
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 40
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 41
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 42
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 43
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 44
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 45
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 46
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 1	 47
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 48
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 49
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 50
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 51
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 52
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 53
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 
 
  DCF_Sig <= '1';			-- Logische 0	 54
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 55
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 56
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 57
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 	     -- Jetzt sind 57 Sekunden vorbei

  DCF_Sig <= '1';			-- Logische 0	 58
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 	     -- Jetzt sind 58 Sekunden vorbei

  
  DCF_Sig <= '1';			-- Logische 0	 59. + Min Sprung
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 1900ms;	 	    -- Jetzt sind 60 Sekunden vorbei

----	  Ende 1. Minute
  
  DCF_Sig <= '1';			-- Logische 0   1
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 
  
  DCF_Sig <= '1';			-- Logische 0	 2
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 3
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 4
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 5
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 6
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 7
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 8
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 9
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 10
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 11
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 12
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

DCF_Sig <= '1';			-- Logische 0	 13
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 14
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 15
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 16
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 17
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 18
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 
  
  DCF_Sig <= '1';			-- Logische 0	 19
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1   20
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 21
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 22
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 1	 23
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 24
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 25
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 26
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 27
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 28
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 1	 29
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 30
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 31
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 32
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 33
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 34
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 1	 35
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 36
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 37
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 1	 38
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 39
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 40
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 41
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 42
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 43
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 44
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 45
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 46
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 1	 47
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 48
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 49
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 50
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 51
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 1	 52
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 53
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 
 
  DCF_Sig <= '1';			-- Logische 0	 54
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 55
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 56
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 

  DCF_Sig <= '1';			-- Logische 0	 57
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 	     -- Jetzt sind 57 Sekunden vorbei

  DCF_Sig <= '1';			-- Logische 0	 58
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 900ms;	 	     -- Jetzt sind 58 Sekunden vorbei

  
  DCF_Sig <= '1';			-- Logische 0	 59. + Min Sprung
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait for 1900ms;	 	    -- Jetzt sind 60 Sekunden vorbei


---	Ende 2. Minute
  DCF_Sig <= '1';			-- Logische 1	 1
  wait for 200ms;	 
  DCF_Sig <= '0';
  wait for 800ms;	 

  DCF_Sig <= '1';			-- Logische 0	 2
  wait for 100ms;	 
  DCF_Sig <= '0';
  wait;

END PROCESS;


-- *** End Test Bench - User Defined Section ***

END;
